#!/bin/bash


# Wrapper script for adding a share definition
# to smb.conf file

returnresult ()
{
MESSAGE="<message>$2</message>"
cat << EOF
<shares>
        <share>
        <operation>ADD</operation>
        <success>$1</success>
	$MESSAGE
        </share>
</shares>
EOF
}

if [ $# -lt 3 ] ; then
	returnresult false "Invalid parameter"
	exit 2
fi


BINDIR=`dirname $0`

#Is a duplicate share name
$BINDIR/sambaShareControl.sh checkname "$1"
if [  $? -eq 10 ] ; then
   returnresult false "Duplicate share name"
   exit
fi

#Not a valid directory
if [ ! -d "$3" ] ; then
   returnresult false "Invalid directory"
   exit
fi

$BINDIR/sambaShareControl.sh add "$1" "$2" "$3" > $BINDIR/smb.conf.new
RETCODE=$?
testparm -s  $BINDIR/smb.conf.new >& /dev/null
if [  "$?" != "0" ] ; then
   returnresult false "Error creating share"
   exit
fi
if [ $RETCODE -eq 10 ] ; then
   mv /etc/samba/smb.conf /etc/samba/smb.conf.bak
   mv $BINDIR/smb.conf.new /etc/samba/smb.conf 
   /etc/init.d/samba restart >& /dev/null
   #Update local properties file with the name, so it can be reused next time
   if [ "$4" != "automode" ] ; then
      $BINDIR/automountsharer.sh "updatesharedetail" "$1" "$3" "$2"
   fi
   returnresult true "$1"
else
   rm -f $BINDIR/smb.conf.new
   returnresult false "Error creating share"
fi
