#!/bin/bash

BINDIR=`dirname $0`
PROPFILE="/etc/samba/automountsharer.properties"
set -e

source $PROPFILE

NOOFENTRIES=${#NAME[@]} 

printShareProperty ()
{
	echo "NAME[$1]=\""${NAME[$1]}\"
	echo "PATH[$1]=\""${PATH[$1]}\"
	echo "COMMENT[$1]=\""${COMMENT[$1]}\"
}

updateShareProperties ()
{
 exec > $BINDIR/auto.properties
 NEWNAME=$1
 NEWPATH=$2
 NEWCOMMENT=$3
 for (( index=0; index < $NOOFENTRIES; index++ ))
 do
	if [ "$NEWPATH" = "${PATH[$index]}" ] ; then
		echo "NAME[$index]=\""$NEWNAME\"
		echo "PATH[$index]=\""$NEWPATH\"
		echo "COMMENT[$index]=\""$NEWCOMMENT\"
	else
		printShareProperty $index
	fi
 done

 /bin/mv $BINDIR/auto.properties $PROPFILE
}

getShareProperty ()
{
 SHAREPATH=$1
 for (( index=0; index < $NOOFENTRIES; index++ ))
 do
        if [ "$SHAREPATH" = "${PATH[$index]}" ] ; then
		export SHARENAME=${NAME[$index]}
		export SHAREPATH=${PATH[$index]}
		export SHARECOMMENT=${COMMENT[$index]}
		echo $SHARENAME
        fi
 done
}

createSambaShare ()
{
 SHAREPATH=$1
 SHARED=
 for (( index=0; index < $NOOFENTRIES; index++ ))
 do
        if [ "$SHAREPATH" = "${PATH[$index]}" ] ; then
                $BINDIR/addShare.sh "${NAME[$index]}" "${COMMENT[$index]}" "${PATH[$index]}" "automode"
                SHARED=1
        fi
 done

 if [ -z $SHARED ]; then
        let NEWINDEX=NOOFENTRIES
        SHARENAME=`/usr/bin/basename ${SHAREPATH}`
        SHARECOMMENT="TonidoPlug ${SHARENAME} share"
        echo "NAME[$NEWINDEX]=\"${SHARENAME}\""  >> $PROPFILE
        echo "PATH[$NEWINDEX]=\"${SHAREPATH}\""  >> $PROPFILE
        echo "COMMENT[$NEWINDEX]=\"${SHARECOMMENT}\""  >> $PROPFILE
        $BINDIR/addShare.sh "${SHARENAME}" "${SHARECOMMENT}" "${SHAREPATH}" "automode"
 fi
}

removeSambaShare ()
{
 SHAREPATH=$1
 for (( index=0; index < $NOOFENTRIES; index++ ))
 do
        if [ "$SHAREPATH" = "${PATH[$index]}" ] ; then
                $BINDIR/removeShare.sh "${NAME[$index]}"
        fi
 done
}

if [ "$1" = "getsharedetails" ] ; then
	getShareProperty "$2"
elif [ "$1" = "updatesharedetail" ] ; then
	if [ -z "$2" -o -z "$3" ] ; then
		echo "No name/path specified"
		exit 1
	fi
	updateShareProperties "$2" "$3" "$4" 
elif [ "$1" = "createsambashare" ] ; then
	echo "Received create share request for $2"
	RETVAL=`$BINDIR/sambaShareControl.sh checkpath "$2"`	
	if [ "$RETVAL" = "1" ] ; then
		echo "$2: already shared"
		exit 1
	fi
	echo "Creating share for $2"
	createSambaShare $2
elif [ "$1" = "removesambashare" ] ; then
	removeSambaShare $2
	exit 0
fi
