#!/bin/bash

PARTITION=${1}
FORMATTYPE=${2}
PARTITIONNAME=`basename ${PARTITION}`
DISK=`echo ${PARTITIONNAME}|cut -c 1-3`
PARTITIONNO=`echo ${PARTITIONNAME}|cut -c 4-`
LABEL="Plug Disk"

trim ()
{
        echo $1
}

if [ -f /sys/block/${DISK}/device/vendor ] ; then
	LABEL=`cat  /sys/block/${DISK}/device/vendor | cut -c 1-10`
	LABEL=`trim "${LABEL}"`
fi
LABEL=`echo $LABEL - $PARTITIONNO`
	
echo ${FORMATTYPE} > /tmp/${PARTITIONNAME}.inprogress
if [ "$FORMATTYPE" = "fat32" ] ; then
	mkfs.vfat -n "${LABEL}" -F 32 ${PARTITION}  2>/dev/null >>/tmp/${PARTITIONNAME}.inprogress
elif [ "$FORMATTYPE" = "ext3" ] ; then
	mkfs.ext3 -L "${LABEL}" ${PARTITION}  2>/dev/null >>/tmp/${PARTITIONNAME}.inprogress
fi
echo > /tmp/${PARTITIONNAME}.done 
partprobe /dev/${DISK}
