#!/bin/bash

USHARECONF=/etc/ushare.conf
if [[ ! -f $USHARECONF ]]; then
	echo "<media></media>"
	exit 
fi

echo "<media>"
echo "<information>"
i=0

for share in `cat $USHARECONF | grep "^USHARE_DIR" | sed -e "s/^USHARE_DIR=//g" -e "s/,/ /g"`
do
	echo "<share"$i">"
	echo $share
	echo "</share"$i">"
	i=$(( $i+1 ))
done
echo "<sharecount>$i</sharecount>"

COUNT=`ps aux | grep ushare | wc -l`
if [[  $COUNT -gt 1 ]]; then
	echo "<status>1</status>"
else
	echo "<status>0</status>"
fi

AUTOSTART=`find /etc/rc2.d/ | grep ushare | wc -l`
echo "<autostart>$AUTOSTART</autostart>"

XBOX=`cat /etc/ushare.conf  |grep "^USHARE_ENABLE_XBOX" | sed -e "s/^USHARE_ENABLE_XBOX=//g"`
if [ "$XBOX" = "yes" ] ; then
	echo "<xbox>1</xbox>"
else
	echo "<xbox>0</xbox>"
fi

DLNA=`cat /etc/ushare.conf  |grep "^USHARE_ENABLE_DLNA" | sed -e "s/^USHARE_ENABLE_DLNA=//g"`
if [ "$DLNA" = "yes" ] ; then
        echo "<dlna>1</dlna>"
else
        echo "<dlna>0</dlna>"
fi


echo "</information>"
echo "</media>"
