#!/bin/sh

#Generates plug information in xml format
OLDVERSIONFILE="/etc/tonidoplug_release"
VERSIONFILE="/etc/tonidofirmware_release"
IMGVERSION=
IMAGETYPE=
getImageVersion()
{
        if [ -f ${OLDVERSIONFILE} ]; then
                IMGVERSION=`cat /etc/tonidoplug_release`
                IMAGETYPE=sheeva
        elif [ -f ${VERSIONFILE} ]; then
                IMGVERSION=`cat ${VERSIONFILE}  | grep VERSION= | cut -d '=' -f 2`
                IMAGETYPE=`cat ${VERSIONFILE}  | grep TYPE= | cut -d '=' -f 2`
        fi
        echo -n "${IMAGETYPE}" | tr '[:lower:]' '[:upper:]'
        echo "-${IMGVERSION}"
}

export IFACE=eth0


echo "<plug>"
echo "<information>"

#Get Mac Address
echo "<mac>"
MAC=`ifconfig eth0 |grep HWaddr | sed -e 's/^.*HWaddr \([:[:xdigit:]]*\).*/\1/'`
echo $MAC
echo "</mac>"

#Get Host Name
echo "<hostname>"
HOSTNAME=`hostname -s`
echo $HOSTNAME
echo "</hostname>"

#Get Domain Name
echo "<domainname>"
DOMAINNAME=`hostname -d`
echo $DOMAINNAME
echo "</domainname>"

#OS Version
echo "<osver>"
OSVER=`cat /etc/lsb-release | head -3 | cut -d= -f2 `
echo $OSVER
echo "</osver>"

#Date
echo "<date>"
DATE=`date`
echo $DATE
echo "</date>"

#Zone
echo "<zone>"
ZONE=`date +%Z`
echo $ZONE
echo "</zone>"

#Processor
echo "<processor>"
PROC=`cat /proc/cpuinfo | grep "Processor" | cut -d: -f 2`
SPEED=`cat /proc/cpuinfo | grep BogoMIPS | cut -d: -f 2`
#echo $PROC
echo "$PROC $SPEED MHz"
echo "</processor>"

#Hardware
echo "<hardware>"
HW=`cat /proc/cpuinfo | grep Hardware | cut -d: -f 2`
echo $HW
echo "</hardware>"

#Memory
echo "<memory>"
MEM=`cat /proc/meminfo | grep MemTotal | cut -d: -f 2 | sed -e 's/^ *//g'`
echo $MEM
echo "</memory>"

#Image Version
echo "<imagever>"
getImageVersion
echo "</imagever>"

echo "</information>"
echo "</plug>"
