#!/bin/bash
# Script to check USB drive presence

if [[ -z $1 ]]; then
     echo "Usage: $0 [USER DATA DIR]"
     exit 2
fi
TONIDOUSERDIR="$1"
SCRIPTDIR=`dirname $0`
MATCH=0
while read device mountpoint fstype remainder; do
      if [[ -f $SCRIPTDIR/IGNOREDATADIR ]]; then
           MATCH=1
           break
      fi
      if [[ $mountpoint == "/" ]]; then
           continue;
      fi
      MATCHLEN=`expr match $TONIDOUSERDIR  "$mountpoint"`
      if [[ $MATCHLEN > 0 ]]; then
           MATCH=1
           break
      fi
done < /proc/mounts

if [[ $MATCH == 1 ]]; then
        echo "Tonido User Directory Mounted"
        exit 0
fi

echo "Tonido User Directory Not Mounted"
exit 1
