#!/bin/bash

if [[ -z $1 ]]; then
	exit 1
fi

oldPlugLED()
{
	#Called when tonidoconsole works normally
	#Calling this will change the led color to green
	if [[ "$1" == "0" ]]; then
		echo none > /sys/devices/platform/leds-gpio/leds/plug\:green\:health/trigger
		exit 0
	fi

	#Called when tonidoconsole dies
	#Calling this will change the led color to light-blue
	if [[ "$1" == "1" ]]; then
		echo default-on > /sys/devices/platform/leds-gpio/leds/plug\:green\:health/trigger
		sleep 30
		exit 0
	fi

	if [[ "$1" == "2" ]]; then
		echo heartbeat > /sys/devices/platform/leds-gpio/leds/plug\:green\:health/trigger
		exit 0
	fi

	#Called when tonidoconsole stopped via initctl
	#Calling this will change the led color to light-blue
	if [[ "$1" == "3" ]]; then
		echo default-on > /sys/devices/platform/leds-gpio/leds/plug\:green\:health/trigger
		exit 0
	fi
}

newPlugLED()
{
	if [[ ! -c /dev/pwrctl ]]; then
		mknod /dev/pwrctl c 221 0
	fi

	#Switch of everything
	pwrctl -o 503
	pwrctl -o 603

	#Called when tonidoconsole works normally
	#Calling this will change the led color to blue
	if [[ "$1" == "0" ]]; then
		pwrctl -o 502
		exit 0
	fi

	#Called when tonidoconsole dies
	#Calling this will change the led color to red
	if [[ "$1" == "1" ]]; then
		pwrctl -o 602
		sleep 30
		exit 0
	fi

	#Calling this will change the led color to blinking blue
	if [[ "$1" == "2" ]]; then
		pwrctl -o 504
		exit 0
	fi

	#Called when tonidoconsole stopped via initctl
	#Calling this will change the led color to light-blue
	if [[ "$1" == "3" ]]; then
		pwrctl -o 504
		pwrctl -o 604
		exit 0
	fi
}

if [[ -f /sys/devices/platform/leds-gpio/leds/plug\:green\:health/trigger ]]; then
	oldPlugLED $@
else
	newPlugLED $@	
fi
