#!/bin/bash

TZ[0]="UTC-12 Kwajalein"
TZ[1]="UTC-11 Samoa"
TZ[2]="UTC-10 Hawaii"
TZ[3]="UTC-9 US/Alaska"
TZ[4]="UTC-8 US/Pacific"
TZ[5]="UTC-7 US/Mountain"
TZ[6]="UTC-6 US/Central"
TZ[7]="UTC-5 US/Eastern"
TZ[8]="UTC-4 Canada/Atlantic"
TZ[9]="UTC-3 Brazil/East"
TZ[10]="UTC-2 Brazil/DeNoronha"
TZ[11]="UTC-1 Atlantic/Cape_Verde"
TZ[12]="UTC London"
TZ[13]="UTC+1 France,Germany,Italy"
TZ[14]="UTC+2 Egypt"
TZ[15]="UTC+3 Moscow,Russia"
TZ[16]="UTC+4 Dubai,UAE"
TZ[17]="UTC+5 Karachi, Pakistan"
TZ[18]="UTC+5:30 Chennai, Calcutta, India"
TZ[19]="UTC+6 Dhaka, Bangladesh"
TZ[20]="UTC+7 Jakarta, Indonesia"
TZ[21]="UTC+8 Hongkong"
TZ[22]="UTC+8 Perth, Australia"
TZ[23]="UTC+8:45 Eucla, Australia"
TZ[24]="UTC+9 Tokyo"
TZ[25]="UTC+9:30 Adelaide, Australia"
TZ[26]="UTC+10 Sydney, Australia"
TZ[27]="UTC+10:30 Lord Howe, Australia"
TZ[28]="UTC+11 Pacific/Noumea"
TZ[29]="UTC+12 Pacific/Auckland"

TZFILE[0]="/usr/share/zoneinfo/Kwajalein"
TZFILE[1]="/usr/share/zoneinfo/Pacific/Samoa"
TZFILE[2]="/usr/share/zoneinfo/US/Hawaii"
TZFILE[3]="/usr/share/zoneinfo/US/Alaska"
TZFILE[4]="/usr/share/zoneinfo/US/Pacific"
TZFILE[5]="/usr/share/zoneinfo/US/Mountain"
TZFILE[6]="/usr/share/zoneinfo/US/Central"
TZFILE[7]="/usr/share/zoneinfo/US/Eastern"
TZFILE[8]="/usr/share/zoneinfo/Canada/Atlantic"
TZFILE[9]="/usr/share/zoneinfo/Brazil/East"
TZFILE[10]="/usr/share/zoneinfo/Brazil/DeNoronha"
TZFILE[11]="/usr/share/zoneinfo/Atlantic/Cape_Verde"
TZFILE[12]="/usr/share/zoneinfo/Europe/London"
TZFILE[13]="/usr/share/zoneinfo/Europe/Paris"
TZFILE[14]="/usr/share/zoneinfo/Egypt"
TZFILE[15]="/usr/share/zoneinfo/Europe/Moscow"
TZFILE[16]="/usr/share/zoneinfo/Asia/Dubai"
TZFILE[17]="/usr/share/zoneinfo/Asia/Karachi"
TZFILE[18]="/usr/share/zoneinfo/Asia/Calcutta"
TZFILE[19]="/usr/share/zoneinfo/Asia/Dhaka"
TZFILE[20]="/usr/share/zoneinfo/Asia/Jakarta"
TZFILE[21]="/usr/share/zoneinfo/Hongkong"
TZFILE[22]="/usr/share/zoneinfo/Australia/Perth"
TZFILE[23]="/usr/share/zoneinfo/Australia/Eucla"
TZFILE[24]="/usr/share/zoneinfo/Asia/Tokyo"
TZFILE[25]="/usr/share/zoneinfo/Australia/Adelaide"
TZFILE[26]="/usr/share/zoneinfo/Australia/Sydney"
TZFILE[27]="/usr/share/zoneinfo/Australia/Lord_Howe"
TZFILE[28]="/usr/share/zoneinfo/Pacific/Noumea"
TZFILE[29]="/usr/share/zoneinfo/Pacific/Auckland"

if [ "$1" = "list" ]; then
echo "<timezones>"
CURRENTTIME=`readlink /etc/localtime`
i=0
for file in ${TZFILE[*]}
do
  echo "<timezone>"
  echo "<index>$i</index>"
  echo "<name>${TZ[$i]}</name>"

  if [ "$file" = "$CURRENTTIME" ]; then
	echo "<selected>true</selected>"
  else
	echo "<selected>false</selected>"
  fi
  let i=i+1
  echo "</timezone>"
done
echo "</timezones>"
elif [ "$1" = "set" ]; then
    INDEX=$2
    if [ -z $INDEX ]; then
	echo "specify index"
        exit 1
    fi
    if [[ $INDEX -gt 29 ||  $INDEX -lt 0 ]]; then
        echo "invalid index"
        exit 1
    fi

    rm -f /etc/localtime
    ln -s ${TZFILE[$INDEX]} /etc/localtime
fi
