#!/bin/bash


# Wrapper script for removing a share definition
# from smb.conf file

if [ $# -lt 1 ] ; then
        echo "Insufficient params specified for share removal"
        exit 1
fi

returnresult ()
{
cat << EOF
<shares>
        <share>
        <operation>REMOVE</operation>
        <success>$1</success>
        </share>
</shares>
EOF

}

BINDIR=`dirname $0`

$BINDIR/sambaShareControl.sh remove $1 > $BINDIR/smb.conf.new
RETCODE=$?
testparm -s  $BINDIR/smb.conf.new >& /dev/null
if [  "$?" != "0" ] ; then
   returnresult false        
   exit
fi

if [ $RETCODE -eq 10 ] ; then
   mv /etc/samba/smb.conf /etc/samba/smb.conf.bak
   mv $BINDIR/smb.conf.new /etc/samba/smb.conf 
   /etc/init.d/samba restart >& /dev/null
   returnresult true
else
   rm -f $BINDIR/smb.conf.new
   returnresult false
fi
