#!/bin/bash

testparm -s >& /dev/null
if [  "$?" != "0" ] ; then
	exit 1
fi

existsInArray ()
{
	if [ -z "$1" ] ; then
		return 0
	fi
	
	for i in ${PATHS2REMOVE[@]}
	do
		PATH2REMOVE=`normalize "$i"`
		if [ $PATH2REMOVE == $1 ]
		then
			return 1
		fi
	done
	return 0
}

normalize ()
{
	DIR=`dirname $1`
	NAME=`basename $1`
	echo "$DIR"/"$NAME"
}

BINDIR=`dirname $0`
SHARELIST=`testparm -s 2>&1 | grep "Processing section" | sed -e "s/Processing section \"\[//" -e "s/\]\"//"`

#If the request if to get details of a share path
if [ "$1" = "info" ] ; then
    MATCHFOUND=
    for share in $SHARELIST
    do 
	SHAREPATH=`testparm -s --section-name=$share --parameter-name=path 2>/dev/null`
	SHAREPATH=`normalize "$SHAREPATH"`
	REQPATH=`normalize $2`
	if [ "$REQPATH" = "$SHAREPATH" ] ; then
	    MATCHFOUND="FOUND"
	    COMMENT=`testparm -s --section-name=$share --parameter-name=comment 2>/dev/null`
	    cat << EOF
<shares>
	<share>
	<operation>INFO</operation>
	<shared>true</shared>
	<success>true</success>
	<name>$share</name>
	<comment>$COMMENT</comment>
	</share>
</shares>
EOF
exit 10
	 fi
    done
    if [ -z $MATCHFOUND ] ; then

cat << EOF
<shares>
   <share>
    	<operation>INFO</operation>
    	<shared>false</shared>
	<success>true</success>
   </share>
</shares>
EOF
exit 0
    fi
elif [ "$1" = "remove" ] ; then
#If the request is to remove a share from the smb.conf file
    MATCHFOUND=
    source $BINDIR/baseSambaConfig.tmpl
    for share in $SHARELIST
    do
	if [ "$2" != "$share" ] ; then
	    echo "["$share"]"
	    for param in comment path
	    do
		echo -n $param"="
		testparm -s --section-name=$share --parameter-name=$param 2>/dev/null
	    done
	else
	     MATCHFOUND="FOUND"
	fi
    done
    if [ ! -z $MATCHFOUND ] ; then
	exit 10   #send a return code to convey the share was found and removed 
    fi
elif [ "$1" = "removeMultiPaths" ] ; then
#If the request is to remove a share from the smb.conf file
    MATCHFOUND=
	shift
    PATHS2REMOVE="$@"
   	
    source $BINDIR/baseSambaConfig.tmpl
    for share in $SHARELIST
    do
	    SHAREPATH=`testparm -s --section-name=$share --parameter-name=path 2>/dev/null`
		SHAREPATH=`normalize "$SHAREPATH"`
		
		existsInArray "$SHAREPATH"
    	if [ "$?" = "0" ] ; then
    		echo "["$share"]"
		    for param in comment path
		    do
				echo -n $param"="
				testparm -s --section-name=$share --parameter-name=$param 2>/dev/null
		    done
    	else
		     MATCHFOUND="FOUND"
		fi
    done
    if [ ! -z $MATCHFOUND ] ; then
		exit 10   #send a return code to convey the share was found and removed 
    fi
elif [ "$1" = "add" -o "$1" = "list" ] ; then
source $BINDIR/baseSambaConfig.tmpl
for share in $SHARELIST
do
    echo "[$share]"
    for param in comment path
    do
	echo -n $param"="
	testparm -s --section-name=$share --parameter-name=$param 2>/dev/null
    done
done
if [ "$1" = "add" ] ; then
	echo [$2]
	echo comment=$3
	echo path=$4
	exit 10 # send retcode 10 to notify that the new configuration was added successfully`
fi
#If the request if to check if a sharename already taken
elif [ "$1" = "checkname" ] ; then
    for share in $SHARELIST
    do
	if [ "$2" = "$share" ] ; then
		exit 10
	fi
    done
    exit 1
#check if a path is already shared
elif [ "$1" = "checkpath" ] ; then
    for share in $SHARELIST
    do
	SHAREPATH=`testparm -s --section-name=$share --parameter-name=path 2>/dev/null`
        if [ "$2" = "$SHAREPATH" ] ; then
		echo "1"
        fi
    done
fi
