#!/bin/bash

DIRNAME=`dirname $0`

if [[ $# -eq 0 ]] ;
then
echo "Specify a network type [static|dhcp]"
exit 1
elif [[ "$1" = "static" && $# -lt 4 ]] ;
then
echo "Insufficient parameters for static network"
exit 1
fi

TYPE=$1
IPADDR=$2
NETMASK=$3
GATEWAY=$4
BCAST=$5

# Get current network card information
# this information will be used to set eth0:0
# virtual card. This will prevent the UI from loosing the 
# control immediately
IPINFO=`ifconfig eth0 | grep "inet "`

if [ ! -z "$IPINFO" ]
then
OLDIP=`echo $IPINFO | grep inet | awk ' { print $2 } ' | cut -d: -f 2`
OLDMASK=`echo $IPINFO | grep inet | awk ' { print $4 } ' | cut -d: -f 2`
OLDBCAST=`echo $IPINFO | grep inet | awk ' { print $3 } ' | cut -d: -f 2`
fi

#Make a backup of existing file
if [ -f /etc/network/interfaces ] ; then
	mv /etc/network/interfaces /etc/network/interfaces.bak
fi
 
#Create the new configuration file
source $DIRNAME/geninterfaces.sh > /etc/network/interfaces

#Restart the network
/etc/init.d/networking restart

#Create the virtual interface
# ifconfig eth0:0 $OLDIP netmask $OLDMASK broadcast $OLDBCAST

exit 0
