#!/bin/bash


WARNING_LIMIT=58
SHUTDOWN_LIMIT=60
INTERNAL_SATA=sda

log ()
{
        logger -t tonido "$*"
}

checkHDDTemp ()
{
        # Check if the drive is SATA
        SATA_NOT_AVAILABLE=`find /sys/devices/platform/ | grep $INTERNAL_SATA | grep marvel`
        if [[ ! -z $SATA_NOT_AVAILABLE ]]; then
                log 'No internal sata found'
                exit 0
        fi

        #TEMP_IN_CELSIUS=`smartctl -d sat -a /dev/sda | grep -i temp | awk '{print $10}'`
	TEMP_IN_CELSIUS=`smartctl -d sat -a /dev/sda | awk ' $1 == 194 ' | awk ' { print $10 } '`
        #log "Detected temperature for drive: $INTERNAL_SATA is $TEMP_IN_CELSIUS"

        if [ ${TEMP_IN_CELSIUS} -ge ${WARNING_LIMIT} ]
        then
                log "WARNING: TEMPERATURE FOR DRIVE: $INTERNAL_SATA exceeded $WARNING_LIMIT"
                exit 1
        fi

        if [ ${TEMP_IN_CELSIUS} -ge ${SHUTDOWN_LIMIT} ]
        then
                log "CRITICAL: TEMPERATURE FOR DRIVE: $INTERNAL_SATA exceeded $SHUTDOWN_LIMIT"
                log "SHUTTING DOWN SYSTEM IN 30 SECONDS"
                (sleep 30 && /sbin/shutdown -h now) &
                exit 2
        fi

        #log "Drive: $INTERNAL_SATA temperature OK."
}


if [[ ! -f /usr/sbin/smartctl ]]; then
        log "smartctl not found"
        exit 0
fi

checkHDDTemp
exit 0
